// GMEApp.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "GMEApp.h"


#include "Gme_i.c"
#include "GmeLib_i.c"
#include "../Mga/MgaLib_i.c"
#include "Parser.h"

#include "GMEstd.h"
#include "GuiMeta.h"
#include "MainFrm.h"
#include "ChildFrm.h"
#include "GMEDoc.h"
#include "GMEView.h"
#include "GMEBrowser.h"
#include "GMEObjectInspector.h"
#include <locale.h>
#include "MgaOpenDlg.h"
#include "GmeDocTemplate.h"
#include "ProjectPropertiesDlg.h"
#include "GmeLib.h"
#include "GMEOLEApp.h"
#include "GMEEventLogger.h"
#include "GMEPrintDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// ATL ///////////////////////////////////////////////////////////////////////////
#include "mga_i.c"
#include "meta_i.c"
#include "Splash.h"
CComModule _Module;
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// CGMEApp

BEGIN_MESSAGE_MAP(CGMEApp, CWinApp)
	//{{AFX_MSG_MAP(CGMEApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_FILE_NEW, OnFileNew)
	ON_UPDATE_COMMAND_UI(ID_FILE_CLOSEPROJECT, OnUpdateFileCloseproject)
	ON_COMMAND(ID_FILE_CLOSEPROJECT, OnFileCloseproject)
	ON_UPDATE_COMMAND_UI(ID_FILE_NEW, OnUpdateFileNew)
	ON_UPDATE_COMMAND_UI(ID_FILE_OPEN, OnUpdateFileOpen)
	ON_COMMAND(ID_EDIT_UNDO, OnEditUndo)
	ON_COMMAND(ID_EDIT_REDO, OnEditRedo)
	ON_UPDATE_COMMAND_UI(ID_EDIT_REDO, OnUpdateEditRedo)
	ON_UPDATE_COMMAND_UI(ID_FILE_EXPORTXML, OnUpdateFileExportxml)
	ON_COMMAND(ID_FILE_EXPORTXML, OnFileExportxml)
	ON_COMMAND(ID_FILE_IMPORTXML, OnFileImportxml)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PROJECTPROPERTIES, OnUpdateEditProjectproperties)
	ON_COMMAND(ID_EDIT_PROJECTPROPERTIES, OnEditProjectproperties)
	ON_COMMAND(ID_FILE_SETTINGS, OnFileSettings)
	ON_COMMAND(ID_FILE_CLEARLOCKS, OnFileClearLocks)
	ON_COMMAND(ID_EDIT_CLEARUNDO, OnEditClearUndo)
	ON_UPDATE_COMMAND_UI(ID_EDIT_CLEARUNDO, OnUpdateEditClearUndo)
	ON_COMMAND(ID_HELP_CONTENTS, OnHelpContents)
	ON_COMMAND(ID_FILE_CHECKALL, OnFileCheckall)
	ON_UPDATE_COMMAND_UI(ID_FILE_CHECKALL, OnUpdateFileCheckall)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVEPROJECT, OnUpdateFileSave)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVEPROJECTAS, OnUpdateFileSaveAs)
	ON_COMMAND(ID_FILE_SAVEPROJECTAS, OnFileSaveAs)
	ON_COMMAND(ID_FILE_SAVEPROJECT, OnFileSave)
	ON_COMMAND(ID_FILE_ABORTPROJECT, OnFileAbortProject)
	ON_UPDATE_COMMAND_UI(ID_FILE_ABORTPROJECT, OnUpdateFileAbortProject)
	ON_COMMAND(ID_FILE_REGCOMPONENTS, OnFileRegcomponents)
	ON_COMMAND(ID_FILE_REGPARADIGMS, OnFileRegparadigms)
	ON_UPDATE_COMMAND_UI(ID_FILE_REGCOMPONENTS, OnUpdateFileRegcomponents)
	ON_UPDATE_COMMAND_UI(ID_FILE_UPDATETHROUGHXML, OnUpdateFileXMLUpdate)
	ON_COMMAND(ID_FILE_UPDATETHROUGHXML, OnFileXMLUpdate)
	ON_COMMAND(ID_FILE_DISPLAY_CONSTRAINTS, OnFileDisplayConstraints)
	ON_UPDATE_COMMAND_UI(ID_FILE_DISPLAY_CONSTRAINTS, OnUpdateFileDisplayConstraints)
	ON_COMMAND(ID_APP_EXIT, OnAppExit)
	ON_UPDATE_COMMAND_UI(ID_EDIT_UNDO, OnUpdateEditUndo)
	//}}AFX_MSG_MAP
	// Standard file based document commands
//	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
//	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, OnUniquePrintSetup) // CWinApp::OnFilePrintSetup)
	// MRU - most recently used project menu
	ON_UPDATE_COMMAND_UI(ID_FILE_MRU_PRJ1, OnUpdateRecentProjectMenu)
	ON_COMMAND_EX_RANGE(ID_FILE_MRU_PRJ1, ID_FILE_MRU_PRJ16, OnOpenRecentProject)
	ON_COMMAND_RANGE(ID_FILE_RUNPLUGIN1, ID_FILE_RUNPLUGIN8, OnRunPlugin)
	ON_COMMAND_RANGE(ID_FILE_INTERPRET1, ID_FILE_INTERPRET18, OnRunInterpreter)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// The one and only CGMEApp object

CGMEApp theApp;

// This identifier was generated to be statistically unique for your app.
// You may change it if you prefer to choose a specific identifier.



/////////////////////////////////////////////////////////////////////////////
// CGMEApp construction

CGMEApp::CGMEApp() :
	m_RecentProjectList(0, "Recent Project List", "Project%d", 4)
{
	multipleView = false;
	labelAvoidance = false;
	// TODO: add construction code here,
	set_terminate(EmergencyTerminate);
	// Place all significant initialization in InitInstance
}


class CGMECommandLineInfo : public CCommandLineInfo {
public:
 	bool bNoProtect, bOpenLast;
 	CGMECommandLineInfo() : bNoProtect(false), bOpenLast(false) { ; }

	virtual void ParseParam(const char* pszParam, BOOL bFlag, BOOL bLast) {
		if(bFlag && !strcmp(pszParam, "d")) bNoProtect = true;
 		else if(bFlag && !strcmp(pszParam, "l")) bOpenLast = true;
		else if(bFlag && !strcmp(pszParam, "REGSERVER")) {
			char c[200];
			GetModuleFileName(NULL, c, sizeof(c));
			CComPtr<ITypeLib> it;
			HRESULT hr = LoadTypeLibEx(CComBSTR(c),REGKIND_REGISTER, &it);
			if(hr == S_OK) { AfxMessageBox("Registered"); exit(0); }
			else { AfxMessageBox("Registration error: " + hr); exit(-1); }
		}
		else if(bFlag && !strcmp(pszParam, "UNREGSERVER")) {
			HRESULT hr = UnRegisterTypeLib(LIBID_GmeLib, 1, 0, LANG_NEUTRAL, SYS_WIN32);
			if(hr == S_OK) { AfxMessageBox("Unregistered"); exit(0); }
			else { AfxMessageBox("Unregistration error: " + hr); exit(-1); }
		}
		else CCommandLineInfo::ParseParam(pszParam, bFlag, bLast);
	}

};


bool CheckInterfaceVersions()	{
		bool err = false;
		LPCOLESTR components[] = {
			L"Mga.MgaProject",
			L"Mga.MgaMetaProject",
			L"Mga.CoreProject",
			L"Mga.MgaRegistrar",
			L"Mga.MgaParser",
			L"Mga.AddOn.ConstraintManager",
			NULL };
		CString errstring;
#if (_WIN32_WINNT >= 0x0400 ) || defined(_WIN32_DCOM) // DCOM
		HRESULT hr = CoInitializeEx(NULL, COINIT_APARTMENTTHREADED);
#else
		HRESULT hr = CoInitialize(NULL);
#endif // DCOM
		char hrbuf[20];
		if(hr != S_OK) AfxMessageBox(CString("Coinitialize failure. Err: #") + ltoa(hr,hrbuf,16));
		for(LPCOLESTR *p = components; *p; p++) {
			MgaInterfaceVersion verid = MgaInterfaceVersion_None;
			CComPtr<IUnknown> unk;
			CString ee;
			if(S_OK != (hr = unk.CoCreateInstance(*p))) {
				errstring.Format("Cannot create object %%S (Err: #%X)", hr);
gerr:
				CString a;
				a.Format(errstring, *p, verid/0x1000, verid%0x1000, MgaInterfaceVersion_Current/0x1000,MgaInterfaceVersion_Current%0x1000);
				AfxMessageBox(a);
				err = true;
				continue;
			}
			CComQIPtr<IMgaVersionInfo> vinf = unk;
			if(!vinf) {
				errstring = "Incompatible version of object %S (does not support version information)";
				goto gerr;
			}
			if(S_OK != vinf->get_version(&verid)) {
				errstring = "Get_Version failed for object %S";
				goto gerr;
			}
			if(verid != MgaInterfaceVersion_Current) {
				errstring = "Interface version for class %S (%d.%d) differs from GME interface version (%d.%d)";
				goto gerr;
			}
		}
		return err;
}


/////////////////////////////////////////////////////////////////////////////
// CGMEApp initialization

BOOL CGMEApp::InitInstance()
{
	// CG: The following block was added by the Splash Screen component.
	CGMECommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);
	
	if( cmdInfo.m_nShellCommand == CCommandLineInfo::FileOpen )
		cmdInfo.m_bShowSplash = false;

	CSplashWnd::EnableSplashScreen(cmdInfo.m_bShowSplash);
	// CG: The following block was inserted by 'Status Bar' component.
	{
		//Set up date and time defaults so they're the same as system defaults
		setlocale(LC_ALL, "");
	}

	if(CheckInterfaceVersions()) return FALSE;


	// Initialize OLE libraries
	if (!AfxOleInit())
	{
		AfxMessageBox(IDP_OLE_INIT_FAILED);
		return FALSE;
	}

	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("GME\\GUI"));

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)
	m_RecentProjectList.ReadList();

	// Load Accelerator Table for CGMEView

	m_GMEView_hAccel = LoadAccelerators(m_hInstance, MAKEINTRESOURCE(IDR_GMEVIEW));
	ASSERT( m_GMEView_hAccel );

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	pDocTemplate = new CGmeDocTemplate(
		IDR_GMETYPE,
		RUNTIME_CLASS(CGMEDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CGMEView));
	pDocTemplate->SetContainerInfo(IDR_GMETYPE_CNTR_IP);
	AddDocTemplate(pDocTemplate);

	// Register all OLE server factories as running.  This enables the
	//  OLE libraries to create objects from other applications.
	COleObjectFactory::RegisterAll();
		// Note: MDI applications register all server objects without regard
		//  to the /Embedding or /Automation on the command line.


	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

#ifdef _DEBUG
	bNoProtect = true;
#else
	bNoProtect = cmdInfo.bNoProtect;
#endif
	
	//initialize the logfile - first check registry to see if the user wants logging
	MSGTRY
	{
		CComPtr<IMgaRegistrar> registrar;
		COMTHROW(registrar.CoCreateInstance(CComBSTR("Mga.MgaRegistrar")));
		VARIANT_BOOL enablelogging;
		COMTHROW( registrar->get_EventLoggingEnabled(REGACCESS_USER, &enablelogging) );
		if(enablelogging != VARIANT_FALSE)
		{
			CGMEEventLogger::initialize();
			CGMEEventLogger::LogGMEEvent("GME started\r\n");
		}
	}
	MSGCATCH("Error while trying to get logfile settings",;);

	// Check to see if launched as OLE server
	if (cmdInfo.m_bRunEmbedded || cmdInfo.m_bRunAutomated)
	{
		// Application was run with /Embedding or /Automation.  Don't show the
		//  main window in this case.
		return TRUE;
	}

	// Updates system registry with all creatable classes (_OLECREATE)
	// PETER: It works only with administrator priviledges
	// COleObjectFactory::UpdateRegistryAll();
	
	// Make sure the type library is registered or dual interface won't work.
	// AfxOleRegisterTypeLib(AfxGetInstanceHandle(), LIBID_GMELib);

	// We don't want a new document at startup
	if( cmdInfo.m_nShellCommand == CCommandLineInfo::FileNew )
		cmdInfo.m_nShellCommand = CCommandLineInfo::FileNothing;
	if( cmdInfo.m_nShellCommand == CCommandLineInfo::FileOpen ) {
		CString conn = cmdInfo.m_strFileName;
		if(conn.Find("=") < 0) {
			conn.Insert(0,"MGA=");
		}
		OpenProject(conn);

		cmdInfo.m_nShellCommand = CCommandLineInfo::FileNothing;
	}
 	else if(cmdInfo.bOpenLast && !m_RecentProjectList[0].IsEmpty()) {
 		OpenProject(m_RecentProjectList[0]);
 		cmdInfo.m_nShellCommand = CCommandLineInfo::FileNothing;
 	}

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The main window has been initialized, so show and update it.
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();


	dynmenus_need_refresh = true;

	GetSettings();

	return TRUE;
}

BOOL CGMEApp::PreTranslateMessage(MSG* pMsg)
{
	// CG: The following lines were added by the Splash Screen component.
	if (CSplashWnd::PreTranslateAppMessage(pMsg))
		return TRUE;

	return CWinApp::PreTranslateMessage(pMsg);
}



/////////////////////////////////////////////////////////////////////////////
// CGMEApp emergency

void CGMEApp::EmergencyTerminate() {
	theApp.EmergencySave();
}

void CGMEApp::EmergencySave() {
	
	CGMEEventLogger::LogGMEEvent("EMERGENCY EVENT\r\n");
	if(mgaProject && (proj_type_is_mga||proj_type_is_xmlbackend)) {
		CString embackupname = currentConnection;
		int p = embackupname.ReverseFind('.');
		if((p == -1) || embackupname.Find('\\',p) != -1) p = embackupname.GetLength();
		CString emcode("-emergency");
		static emnum;
		char emfield[10];
		sprintf(emfield,"%d",++emnum);
		emcode += emfield;
		embackupname.Insert(p,emcode);
#pragma warning(disable: 4310) // cast truncates constant value
		HRESULT hr = mgaProject->Save(PutInBstr(embackupname), VARIANT_TRUE);
#pragma warning(default: 4310) // cast truncates constant value
		{
			char buf[200];
			sprintf(buf, "Emergency event. Your current work %s been saved to %s.\nThe original project file has not been modified.\nWe apologize for the inconvenience.", (hr == S_OK)? "has" : "may have", embackupname);
			AfxMessageBox(buf);
		}
		m_RecentProjectList.Add(embackupname);
		m_RecentProjectList.WriteList();
	}
	else AfxMessageBox("Emergency event. Please, restart GME.");
}

int CGMEApp::Run() {
	if(bNoProtect) return CWinApp::Run();
	else while(true) {
		try {
			return CWinApp::Run();
		} catch(...) {
			EmergencySave();
			
			// Modified by Peter:let's exit after emergency event
			abort_on_close = true;
			BeginWaitCursor();
			if(CGMEDoc::theInstance) {
				CGMEDoc::theInstance->OnCloseDocument(true);
			}
			EndWaitCursor();
			return -1;
			// End by Peter
		}
	}
}

/////////////////////////////////////////////////////////////////////////////
// CGMEApp Autosave
void CGMEApp::Autosave()
{

	if(mgaProject == NULL || (!proj_type_is_mga) || (!autosaveEnabled)) {
		// The KillTimer function does not remove WM_TIMER messages 
		// already posted to the message queue ...
		CGMEEventLogger::LogGMEEvent("WARNING: CGMEApp::Autosave was called with no active project or autosave disabled.\r\n");
		return;
	}

	// Figure out the filename
	CString conn;
	if (autosaveUseDir) {
		int p = currentConnection.ReverseFind('\\');
		CString fname = currentConnection.Mid(p + 1);

		conn = CString("MGA=") + autosaveDir + CString("\\") + fname + GME_AUTOSAVE_EXTENSION;
	}
	else {
		conn = currentConnection + GME_AUTOSAVE_EXTENSION;
	}

	// Check if in transaction
	bool inTrans;
	try {
		long status;
		COMTHROW(mgaProject->get_ProjectStatus(&status));
		inTrans = (status & 0x08L) != 0;
	}
	catch(hresult_exception &) {
		// Safe presumption
		inTrans = true;
	}

	if (inTrans) {
		CGMEEventLogger::LogGMEEvent("WARNING: CGMEApp::Autosave failed " + 
			conn + ". We are in transaction.\r\n");
		return;
	}

	// Save the project
	try {
#pragma warning(disable: 4310) // cast truncates constant value
		COMTHROW(mgaProject->Save(CComBSTR(conn), VARIANT_TRUE));
#pragma warning(default: 4310) // cast truncates constant value
		CGMEEventLogger::LogGMEEvent("CGMEApp::Autosave succeeded " + 
			conn + "\r\n");
	}
	catch(hresult_exception &e) {
		CGMEEventLogger::LogGMEEvent("WARNING: CGMEApp::Autosave failed " + 
			conn + " " + e.what() + "\r\n");
	}
}


/////////////////////////////////////////////////////////////////////////////
// CGMEApp MGA project management


void CGMEApp::CloseProject(bool updateStatusBar)
{

	CWaitCursor wait();
	
	if(CGMEDataSource::myData) // it is true when object copied to the clipboard from the view
		OleFlushClipboard();
	
	if( CMainFrame::theInstance != NULL ) {
		CMainFrame::theInstance->StopAutosaveTimer();
		CMainFrame::theInstance->SetPartBrowser(NULL);
		CMainFrame::theInstance->SetPartBrowserBg(::GetSysColor(COLOR_APPWORKSPACE));
	}

	if( CGMEBrowser::theInstance != NULL )
		CGMEBrowser::theInstance->CloseProject();
	
	if(CGMEObjectInspector::theInstance!=NULL)
		CGMEObjectInspector::theInstance->CloseProject();

	if(CGMESearch::theInstance!=NULL)
		CGMESearch::theInstance->CloseProject();



	if( guiMetaProject != NULL )
	{
		delete guiMetaProject;
		guiMetaProject = NULL;
	}

	mgaMetaProject = NULL;
	UpdateComponentLists();

#pragma warning(disable: 4310) // cast truncates constant value
	if( mgaProject != NULL ) {
		mgaClient = NULL;
		if(mgaProject->Close(abort_on_close ? VARIANT_TRUE : VARIANT_FALSE) != S_OK) {
			AfxMessageBox(CString("Error occured ") + (abort_on_close ? "aborting" : "closing") + " the project");
		}
		mgaProject.Release();
	}
#pragma warning(default: 4310) // cast truncates constant value
	

	if(updateStatusBar) {
		CMainFrame::theInstance->WriteStatusParadigm("-");
		CMainFrame::theInstance->WriteStatusMode("EDIT");
		CMainFrame::theInstance->WriteStatusZoom(100);
	}
	projectName.Empty();
	ChangedProjectConnStrings();

	if(CGMEDoc::theInstance)
		CGMEDoc::theInstance->SetTitle("");
	if(CMainFrame::theInstance) {
		CMainFrame::theInstance->SetTitle(m_pszAppName);
		CMainFrame::theInstance->UpdateTitle("");
	}
}


void CGMEApp::ChangedProjectConnStrings() {
	if(!mgaProject) {  // project closed
		paradigmDir.Empty();
		projectDir.Empty();
		proj_type_is_mga = false;
        proj_type_is_xmlbackend = false;
		return;
	}
	CString conn, metaconn;
	CComBstrObj cc;
	conn = cc;
	COMTHROW(mgaProject->get_ProjectConnStr(PutOut(cc)));
	conn = cc;
	cc.Empty();
	COMTHROW(mgaProject->get_ParadigmConnStr(PutOut(cc)));
	metaconn = cc;
	if(!conn.IsEmpty()) {
		TCHAR cd[200];
		GetCurrentDirectory(200, cd);
		projectDir = cd;
		if (conn.Find("MGA=") == 0) {
			proj_type_is_mga = true;
			int epos = conn.ReverseFind('\\');
			if(epos >= 4) {
				projectDir = conn.Mid(4, epos-4);
				if(projectDir.IsEmpty()) projectDir= '\\';
				SetCurrentDirectory(projectDir);
			}
		}
		else proj_type_is_mga = false;

        if( conn.Find("MGX=") == 0 ) 
            proj_type_is_xmlbackend = true;
        else
            proj_type_is_xmlbackend = false;
	}       
	if(!metaconn.IsEmpty()) {
		if (metaconn.Find("MGA=") == 0) {
			int epos = metaconn.ReverseFind('\\');
			if(epos >= 4) {
				paradigmDir = metaconn.Mid(4, epos-4);
				if(paradigmDir.IsEmpty()) paradigmDir= '\\';
			}
		}
	}
}


// throws exceptions!!
void CGMEApp::UpdateProjectName() {
	if( mgaProject == NULL ) {
		projectName.Empty();
	}
	else {


		CComObjPtr<IMgaTerritory> terry;
		COMTHROW(mgaProject->CreateTerritory(NULL, PutOut(terry)) );
		CComBSTR nm;
	
		MSGTRY
		{
			COMTHROW(mgaProject->BeginTransaction(terry,TRANSACTION_GENERAL));
			COMTHROW(mgaProject->get_Name(&nm));
			COMTHROW(mgaProject->CommitTransaction());
		}
		MSGCATCH("Error getting project name", mgaProject->AbortTransaction())

		CopyTo(nm,projectName);
	}

	if(CGMEDoc::theInstance)
		CGMEDoc::theInstance->SetTitle(projectName);
	CMainFrame::theInstance->UpdateTitle(projectName);
}

void CGMEApp::FindConstraintManager() {
		CComPtr<IMgaComponents> comps;
		COMTHROW( mgaProject->get_AddOnComponents(&comps));
		MGACOLL_ITERATE(IMgaComponent, comps) {
			CComBSTR name;
			COMTHROW(MGACOLL_ITER->get_ComponentName(&name));
			if(name == "ConstraintManager") {
				mgaConstMgr = CComQIPtr<IMgaComponentEx>(MGACOLL_ITER); 
#pragma warning(disable: 4310) // cast truncates constant value
				COMTHROW(mgaConstMgr->put_InteractiveMode(VARIANT_TRUE));
#pragma warning(default: 4310) // cast truncates constant value
				break;
			}
		} MGACOLL_ITERATE_END;
}



void CGMEApp::UpdateComponentLists(bool restart_addons) {
		plugins .RemoveAll();
        pluginTooltips.RemoveAll();
		interpreters.RemoveAll();
        interpreterTooltips.RemoveAll();
		CStringArray tempaddons; tempaddons.Copy(addons);
		addons.RemoveAll();
		mgaConstMgr = NULL;
		if(mgaMetaProject) {
			CComBSTR b;            
			COMTHROW(mgaMetaProject->get_Name(&b));
			CComPtr<IMgaRegistrar> reg;
			COMTHROW(reg.CoCreateInstance(CComBSTR("Mga.MgaRegistrar")));
			{
				CComVariant v;
				COMTHROW(reg->get_AssociatedComponents(b, COMPONENTTYPE_PLUGIN, REGACCESS_BOTH, &v));
				CopyTo(v, plugins);			    
			}
			{
				CComVariant v;
				COMTHROW(reg->get_AssociatedComponents(b, COMPONENTTYPE_INTERPRETER, REGACCESS_BOTH, &v));
				CopyTo(v, interpreters);
			}
			{
				CComVariant v;
				COMTHROW(reg->get_AssociatedComponents(b, COMPONENTTYPE_ADDON, REGACCESS_BOTH, &v));

				CopyTo(v, addons);
				if(restart_addons) {
					bool redo = false;
					if(tempaddons.GetSize() != addons.GetSize()) redo = true;
					else {
						for(int j = 0 ; j < tempaddons.GetSize(); j++) {
							if(addons[j].Compare(tempaddons[j])) {
								redo = true;
								break;
							}
						}
					}
					if(redo && AfxMessageBox("AddOn configuration has changed.\nRestart addons?", MB_YESNO) == IDYES) {
						COMTHROW(mgaProject->EnableAutoAddOns(VARIANT_FALSE));
#pragma warning(disable: 4310) // cast truncates constant value
						COMTHROW(mgaProject->EnableAutoAddOns(VARIANT_TRUE));
#pragma warning(default: 4310) // cast truncates constant value
					}
				}
			}
			// access constraint mgr
			FindConstraintManager();
	
		}
		dynmenus_need_refresh = true;


// Update the Component toolbar

		if(!CMainFrame::theInstance) return;
		CComponentBar &cb = CMainFrame::theInstance->m_wndComponentBar;
		CToolBarCtrl &tbc = cb.GetToolBarCtrl();
		cb.ShowWindow(SW_HIDE);

		for (int bCnt = tbc.GetButtonCount(); bCnt > 0;) {
			tbc.DeleteButton(--bCnt);
		}

		CComPtr<IMgaRegistrar> reg;
		if(reg.CoCreateInstance(L"Mga.MgaRegistrar") != S_OK) return;
		if(!mgaMetaProject) return;

		CImageList imlist;
		imlist.Create(15,16,ILC_MASK, 0, 20);
		CImageList *oldlist = tbc.SetImageList(&imlist);
		if (oldlist) {
			oldlist->DeleteImageList();
		}


		for(int i = 0; i < plugins.GetSize() + interpreters.GetSize(); ++i)	{
            // insert separator between plugin and interpreter icons (if at least one plugin exits)
			if((i == plugins.GetSize()) && (i != 0)) {
				TBBUTTON but = { 0, 0, TBSTATE_ENABLED, TBSTYLE_SEP, 0,0 };
				tbc.AddButtons(1,&but);
			}
			CString bico, tooltip;;
			CComPtr<IMgaComponent> loadedcomp;
			CComBSTR compname;
			if(i < plugins.GetSize()) compname = plugins[i];
			else compname = interpreters[i-plugins.GetSize()];
			HRESULT s;
            s = reg->get_ComponentExtraInfo(REGACCESS_PRIORITY, compname, CComBSTR("Tooltip"), PutOut(tooltip));
            if(s != S_OK || tooltip.IsEmpty())
                tooltip = compname;
            if(i < plugins.GetSize())
                pluginTooltips.Add( tooltip );
            else
                interpreterTooltips.Add( tooltip );
            s = reg->get_ComponentExtraInfo(REGACCESS_PRIORITY, compname, CComBSTR("Icon"), PutOut(bico));
			if(s != S_OK || bico.IsEmpty()) continue;
			
			HICON hic = NULL, hictofree = NULL;
			int cpos;
			if((cpos = bico.Find(',')) >= 0) {  //   <modulename>,<resourceID>
				HMODULE hm = NULL;
				if(cpos) {  // module name present;
					hm = GetModuleHandle(bico.Left(cpos));
					if(!hm) {
						loadedcomp.CoCreateInstance(compname);
						hm = GetModuleHandle(bico.Left(cpos));
					}
				}
				else {
					CString modname;
					reg->get_LocalDllPath(compname, PutOut(modname));			
					if(modname) {
						loadedcomp.CoCreateInstance(compname);
						CString mn(modname);
						hm = GetModuleHandle(mn);
					}
				}
				if( hm != NULL ) {
				 hic = ::LoadIcon(hm, bico.Mid(cpos+1));
/*
				 HRSRC res = ::FindResource(hm, bico.Mid(cpos+1), RT_GROUP_ICON);
				 res = ::FindResource(hm, MAKEINTRESOURCE(201), RT_GROUP_ICON);
				 res = ::FindResource(hm, "IDI_COMPICON", RT_GROUP_ICON);
				 if(res) {
                    HGLOBAL hg;  
					hic = CreateIconFromResourceEx((LPBYTE)LockResource(hg = LoadResource(hm, res)), 
													SizeofResource(hm, res), 
													true,
													0x30000,
													GetSystemMetrics(SM_CXICON),
													GetSystemMetrics(SM_CYICON),
													LR_DEFAULTCOLOR);
// TODO:					FreeResource(hg);
				 }
*/
				}
			}
			else {				  //    simple filename
				hic = hictofree = (HICON)LoadImage(NULL, bico, IMAGE_ICON, 0, 0, LR_LOADFROMFILE);
			}
			if(!hic) hic = LoadIcon(IDI_COMPNOTFOUND);

			TBBUTTON but = { 0, 0, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0};
			but.iBitmap = imlist.Add(hic);
			if(hictofree) DestroyIcon(hictofree);
			if(i < plugins.GetSize()) but.idCommand = ID_FILE_RUNPLUGIN1 + i;
			else but.idCommand = ID_FILE_INTERPRET1 + i-plugins.GetSize();
	//		CString strx(plugins[i]);
	//		strx += '\0';
	//		but.iString = tbc.AddStrings(strx);
			tbc.AddButtons(1,&but);
		}
		cb.ShowWindow(SW_SHOW);
		
		imlist.Detach();
}

void CGMEApp::UpdateDynMenus(CMenu *filemenu)   {
	if(!dynmenus_need_refresh) return;
	ASSERT(filemenu);
	for(UINT idx = 0; idx < filemenu->GetMenuItemCount(); idx++) {
		CString label;
		filemenu->GetMenuString(idx,label,MF_BYPOSITION);
		if(!label.CompareNoCase("R&un Plug-In")) {
			filemenu->DeleteMenu(idx,MF_BYPOSITION);
			CMenu pluginmenu;
			pluginmenu.CreatePopupMenu();
			for(int i = 0; i < plugins.GetSize(); ++i)	{
				pluginmenu.AppendMenu(MF_ENABLED, ID_FILE_RUNPLUGIN1 + i,pluginTooltips[i]);
			}
			filemenu->InsertMenu(idx,
						plugins.GetSize() ? MF_BYPOSITION|MF_POPUP|MF_ENABLED: MF_BYPOSITION|MF_POPUP|MF_GRAYED,
						(UINT)pluginmenu.Detach(),label);
		}
		if(!label.CompareNoCase("Run In&terpreter")) {
			filemenu->DeleteMenu(idx,MF_BYPOSITION);
			CMenu pluginmenu;
			pluginmenu.CreatePopupMenu();
			for(int i = 0; i < interpreters.GetSize(); ++i)	{
				pluginmenu.AppendMenu(MF_ENABLED, ID_FILE_INTERPRET1 + i,interpreterTooltips[i]);
			}
			filemenu->InsertMenu(idx,
						interpreters.GetSize() ? MF_BYPOSITION|MF_POPUP|MF_ENABLED: MF_BYPOSITION|MF_POPUP|MF_GRAYED,
						(UINT)pluginmenu.Detach(),label);
		}
	}
	dynmenus_need_refresh = false;
}


// throws exceptions!!
void CGMEApp::AfterOpenOrCreateProject(const CString &conn) {
	UpdateProjectName();
	if( mgaProject != NULL ) {
		abort_on_close = false;
// get meta
		COMTHROW( mgaProject->get_RootMeta(&mgaMetaProject) );
		UpdateComponentLists();

// create guimetaproject
		ASSERT( guiMetaProject == NULL );
		guiMetaProject = new CGuiMetaProject(mgaMetaProject);
		CMainFrame::theInstance->WriteStatusParadigm(guiMetaProject->displayedName);
		CMainFrame::theInstance->SetTitle(guiMetaProject->displayedName);
		UpdateProjectName();

// Register OLE Server / MGA Client
		CGMEOLEApp *oleApp = new CGMEOLEApp();
		CComBSTR clientName(OLESTR("GME.Application"));
		COMTHROW(mgaProject->RegisterClient(clientName, oleApp->GetIDispatch(FALSE), &mgaClient));
		COMTHROW(oleApp->GetIDispatch(FALSE)->Release());	// Do not hold a reference, hopefully the returned client holds it

// notify browser
		ASSERT( CGMEBrowser::theInstance != NULL );
		CGMEBrowser::theInstance->SetProject(mgaProject);

// notify object inspector
		ASSERT(CGMEObjectInspector::theInstance!=NULL);
		CGMEObjectInspector::theInstance->SetProject(mgaProject);

// notify search control
		ASSERT(CGMESearch::theInstance!=NULL);
		CGMESearch::theInstance->SetProject(mgaProject);


// change dir
		ChangedProjectConnStrings();
// record connection name
		currentConnection = conn;
		m_RecentProjectList.Add(conn);
		m_RecentProjectList.WriteList();
		if (!CGMEDoc::theInstance) {
			CWinApp::OnFileNew();
		}
// start autosave
		if (autosaveEnabled) {
			CMainFrame::theInstance->StartAutosaveTimer(autosaveFreq);
		}
	}
}


static int guidcmp(VARIANT &qGUID, VARIANT &pGUID)	{
	GUID g1, g2;
	CopyTo(qGUID, g1);
	CopyTo(pGUID, g2);
	return memcmp(&g1, &g2, sizeof(g1));
}

static int versioncmp(CComBSTR &qVer, CComBSTR &pVer) {
	CString q(qVer);
	CString p(pVer);

	if ((!p.IsEmpty()) && (!q.IsEmpty())) {
		return p.Compare(q);
	}
	return 1;
}


bool DiagnoseParadigm(CString metaname, bool syscheck = false) {
	CComPtr<IMgaRegistrar> reg;
	try {
		HRESULT hr = reg.CoCreateInstance(CComBSTR("Mga.MgaRegistrar"));
		if(hr != S_OK) {
			throw CString("Cannot create the registrar component\n"
						  "We recommend you reinstall GME");
		}
		CComBSTR conn;
		CComVariant guid;
		hr = reg->QueryParadigm(CComBSTR(metaname), &conn, &guid, 
			syscheck ? REGACCESS_SYSTEM : REGACCESS_PRIORITY);
		if(hr != S_OK) {
			throw CString("Cannot access registry info for paradigm " + metaname +
						  "\nWe recommend you remove and re-register the paradigm");
		}
		CComObjPtr<IMgaMetaProject> paradigm;
		hr =  paradigm.CoCreateInstance(OLESTR("MGA.MgaMetaProject"));
		if(hr != S_OK) {
			throw CString("Cannot create the meta component\n"
						  "We recommend you reinstall GME");
		}

		hr = paradigm->Open(conn);

		if(hr != S_OK) {
			throw CString("Cannot open the paradigm " + metaname + "\n"
						  "Probable cause is file non-existence,\n"
						  "insufficient access, or format error\n"
						  "Connection string: " + CString(conn));
		}


		CComBSTR parname;
		CComVariant gguid;
		hr = paradigm->get_Name(&parname);
		if(hr == S_OK) paradigm->get_GUID(&gguid);
		hr |= paradigm->Close();

		if(hr != S_OK) {
			throw CString("Cannot read the paradigm " + metaname + "\n"
						  "Probable cause is file format error\n"
						  "Connection string: " + CString(conn));
		}
		if(!(parname == metaname)) {
			throw CString("The paradigm opened '" + CString(parname) + "'\n"
		 				  "differs from the requested paradigm '"+ metaname + "'\n"
						  "We recommend you unregister '" + metaname + "'\n"
						  "Connection string: " + CString(conn));

		}

		CComBstrObj parg1, parg2;
		GUID g;
		CopyTo(gguid, g);
		CopyTo(g, parg1);
		CopyTo(guid, g);
		CopyTo(g, parg2);
		if(parg1 != parg2) {
			throw CString("The GUID in paradigm '" + CString(parname) + "'\n"
						  "{" + CString(parg1) + "}\n"
		 				  "differs from the requested GUID for '"+ metaname + "'\n"
						  "{" + CString(parg2) + "}\n"
						  "We recommend you unregister '" + metaname + "'\n"
						  "Connection string: " + CString(conn));
		}
	} catch( CString &c) {
		if(!syscheck) {
			AfxMessageBox(c); 
			CComBSTR cc; CComVariant gg;
			if(reg && E_NOTFOUND != reg->QueryParadigm(CComBSTR(metaname), &cc, &gg, REGACCESS_SYSTEM)) {
				if(DiagnoseParadigm(metaname, true)) {
					AfxMessageBox("SYSTEM registry for '" + metaname + "' is correct\n"
								"We recommend you remove the USER registration for " + metaname);
				}
				else {
					AfxMessageBox("SYSTEM registry for '" + metaname + "' is also incorrect\n"
								"We recommend you reinstall the paradigm.");
				}
			}
		}
		return false;
	}
	catch(...) {
		return false;
	}
	return true;
}



void CGMEApp::OpenProject(const CString &conn) {

	MSGTRY
	{
		CWaitCursor wait();

		ASSERT( mgaProject == 0 );
		COMTHROW( mgaProject.CoCreateInstance(OLESTR("Mga.MgaProject")) );

		VARIANT_BOOL readable_only;

#pragma warning(disable: 4310) // cast truncates constant value
		COMTHROW( mgaProject->EnableAutoAddOns(VARIANT_TRUE));
#pragma warning(default: 4310) // cast truncates constant value
		HRESULT hr = mgaProject->Open(PutInBstr(conn), &readable_only);
		if(hr != S_OK) {
			CComBSTR parn;
			CComBSTR parv;
			long version;
			CComVariant parg;
			VARIANT_BOOL ro_mode;
			if(S_OK != mgaProject->QueryProjectInfo(PutInBstr(conn), &version, &parn, &parv, &parg, &ro_mode)) {
				AfxMessageBox("Cannot query project information. Possible cause: missing/corrupt project file or database");
				COMTHROW(hr);
			}
			while(hr) {
				CString msg;
				CComVariant guidpar;
				CString newparname;
				bool tryit = false;

				if(hr == E_MGA_MODULE_INCOMPATIBILITY) {
					msg = "WARNING: The project data is not in the current MGA format\n"
						"Do you want to upgrade it?";
					if (AfxMessageBox(msg ,MB_OKCANCEL) == IDOK) {
						tryit = true;
					}
				}
				if(hr == E_MGA_PARADIGM_INVALID) {
					msg = "WARNING: Project could not access its original version of\n"
						"paradigm '" + CString(parn) + "'\n"
						"Do you want to try with the current version of the paradigm?";
					if (AfxMessageBox(msg ,MB_OKCANCEL) == IDOK) {
						guidpar = true;
						tryit = true;
					}
				}
				if(hr == E_MGA_PARADIGM_NOTREG) {
					msg = "WARNING: Project could not access its paradigm '" + CString(parn) + "'\n" 
						" (Eg.: In GME3 the MetaGME2000 paradigm was renamed to MetaGME)\n"
						"Do you want to open it with an other registered paradigm ?";
					if (AfxMessageBox(msg ,MB_OKCANCEL) == IDOK) {
					
						CComObjPtr<IMgaLauncher> launcher;
						COMTHROW( launcher.CoCreateInstance(CComBSTR(L"Mga.MgaLauncher")) );
						if (SUCCEEDED(launcher->MetaDlg(METADLG_NONE))) {
							guidpar = true;
							tryit = true;
							newparname.Empty();
							COMTHROW( launcher->get_ParadigmName(PutOut(newparname)) );
						}
					}
				}
				if(hr == E_MGA_META_INCOMPATIBILITY && (parv.Length() > 0)) {
					msg = "WARNING: Versioned project is not compatible with the paradigm '" + CString(parn) + "'\n" 
						" (Eg.: Same version string was assigned to incompatible paradims)\n"
						"Do you want to open it based on the paradigm GUID?";
					if (AfxMessageBox(msg ,MB_OKCANCEL) == IDOK) {
						guidpar = parg;
						tryit = true;
						newparname = parn;
					}
				}
				if(tryit) {
					hr = mgaProject->OpenEx(PutInBstr(conn), CComBSTR(newparname), guidpar);
					if(hr == E_MGA_PARADIGM_NOTREG || hr == E_MGA_PARADIGM_INVALID) {
						DiagnoseParadigm(CString(parn));
					}
				}
				else break;
			}
			if(hr == E_MGA_COMPONENT_ERROR) {
				AfxMessageBox("ERROR: Some automatic addon components could not start up\n");
			}
			COMTHROW(hr);
		}

		if(readable_only != VARIANT_FALSE) {
			AfxMessageBox("WARNING: Project file is read-only\nChange file access or use Save As to save your work");
		}
		else {
			CComVariant g, g2;
			CComBSTR pname; 
			CComBSTR pver, pver2;
			{
				CComPtr<IMgaTerritory> t;
				COMTHROW(mgaProject->CreateTerritory(NULL, &t, NULL));
				COMTHROW(mgaProject->BeginTransaction(t, TRANSACTION_READ_ONLY));
				COMTHROW(mgaProject->get_MetaName(&pname));
				COMTHROW(mgaProject->get_MetaGUID(&g));
				COMTHROW(mgaProject->get_MetaVersion(&pver));
				// COMTHROW(mgaProject->AbortTransaction()); PETER: Why abort ?
				COMTHROW(mgaProject->CommitTransaction());
				CComPtr<IMgaRegistrar> mgareg;
				COMTHROW(mgareg.CoCreateInstance(OLESTR("MGA.MgaRegistrar")));
				CComBSTR connstr;
				COMTHROW(mgareg->QueryParadigm(pname, &connstr, &g2, REGACCESS_PRIORITY));
				mgareg->VersionFromGUID(pname, g2, &pver2, REGACCESS_PRIORITY);
			}
			if(guidcmp(g, g2) && versioncmp(pver, pver2)) {
				int answer = AfxMessageBox("The paradigm used to open this file is not the current version\n"
								"Do you want to upgrade to the current paradigm?"	,MB_YESNO);
				if(answer == IDYES) {
					COMTHROW(mgaProject->Close());
					HRESULT hr = mgaProject->OpenEx(PutInBstr(conn), pname, g2);
					if(hr == E_MGA_PARADIGM_NOTREG || hr == E_MGA_PARADIGM_INVALID) {
						AfxMessageBox("Paradigm error");
						DiagnoseParadigm(CString(pname));
					}
					else if(hr != S_OK) {
						AfxMessageBox("Upgrade failed, probably due to incompatibility.\n"
									   "You can probably reopen the file without upgrade,\n"
									   "And use the 'Upgrade through XML' function later.");
					}
					else readable_only = false;
					COMTHROW(hr);
				}
			}	
		}
		AfterOpenOrCreateProject(conn);
	}
	MSGCATCH("Could not open project", CloseProject())
	
	UpdateProjectName();

}



void CGMEApp::CreateProject(const CString &metaname, const CString &conn)
{
	CString msg;
	try
	{
		CWaitCursor wait();

		// create the project
		msg = "Fatal error while initializing project";
		ASSERT( mgaProject == 0 );
		COMTHROW( mgaProject.CoCreateInstance(L"Mga.MgaProject") );
		ASSERT( mgaProject != NULL );

#pragma warning(disable: 4310) // cast truncates constant value
		COMTHROW( mgaProject->EnableAutoAddOns(VARIANT_TRUE));
#pragma warning(default: 4310) // cast truncates constant value
		msg = "Could not create project";
		HRESULT hr = mgaProject->Create(PutInBstr(conn), PutInBstr(metaname)) ;
	    if(hr == E_MGA_PARADIGM_NOTREG || hr == E_MGA_PARADIGM_INVALID) {
			TCHAR buf[200];
		    sprintf(buf, "Could not open current version of paradigm %s", 
				metaname);

			AfxMessageBox(buf);
			DiagnoseParadigm(metaname);
		}
	    if(hr == E_MGA_COMPONENT_ERROR) {
			AfxMessageBox("ERROR: Some automatic addon components could not start up\n");
		}
	    COMTHROW(hr);

		AfterOpenOrCreateProject(conn);
	}
	MSGCATCH("Could not create project", CloseProject())
}


void CGMEApp::SaveProject(const CString &conn) {
	if( mgaProject != NULL ) {
		HRESULT hr = mgaProject->Save(CComBSTR(conn));
		if(hr != S_OK) {
			AfxMessageBox("ERROR: Could not save project\nCheck access permissions");
		}
	}

	if ((!conn.IsEmpty()) && (currentConnection != conn)) {
		ChangedProjectConnStrings();
		currentConnection = conn;
		m_RecentProjectList.Add(conn);
		m_RecentProjectList.WriteList();
	}
}	



// ********************************************************************************************


void CGMEApp::GetSettings()
{
	MSGTRY
	{
		CComObjPtr<IMgaRegistrar> registrar;
		COMTHROW( registrar.CoCreateInstance(L"Mga.MgaRegistrar") );

		// Icons
		CComBSTR bstr;
		COMTHROW( registrar->get_IconPath(REGACCESS_BOTH,&bstr));
		CopyTo(bstr,bitmapPath);

		// Multiview
		VARIANT_BOOL enabledmv;
		COMTHROW( registrar->get_ShowMultipleView(REGACCESS_USER, &enabledmv) );
		multipleView = (enabledmv != VARIANT_FALSE);

		// Autosave
		VARIANT_BOOL autosaveenable;
		COMTHROW( registrar->get_AutosaveEnabled(REGACCESS_USER, &autosaveenable) );
		autosaveEnabled = (autosaveenable == VARIANT_FALSE) ? FALSE : TRUE;

		long autosavefreq;
		COMTHROW( registrar->get_AutosaveFreq(REGACCESS_USER, &autosavefreq) );
		autosaveFreq = (int)autosavefreq;

		VARIANT_BOOL autosaveusedir;
		COMTHROW( registrar->get_AutosaveUseDir(REGACCESS_USER, &autosaveusedir) );
		autosaveUseDir = (autosaveusedir == VARIANT_FALSE) ? 0 : 1;

		COMTHROW( registrar->get_AutosaveDir(REGACCESS_USER, PutOut(autosaveDir)) );

		//Event Logging
		VARIANT_BOOL enablelogging;
		COMTHROW( registrar->get_EventLoggingEnabled(REGACCESS_USER, &enablelogging) );
		if(enablelogging != VARIANT_FALSE)
		{
			CGMEEventLogger::initialize();
			CGMEEventLogger::LogGMEEvent("CGMEApp::GetSettings() Event Logging Enabled\r\n");
		}
		else
		{
			CGMEEventLogger::LogGMEEvent("CGMEApp::GetSettings() Event Logging Disabled\r\n");
			CGMEEventLogger::StopLogging();
		}

		
		// Autorouter
		VARIANT_BOOL labelavoidance;
		COMTHROW( registrar->get_LabelAvoidance(REGACCESS_USER, &labelavoidance) );
		labelAvoidance = (labelavoidance != VARIANT_FALSE);
	}
	MSGCATCH("Error while trying to get program settings",;);
	if(CGMEDoc::theInstance) {
		if (autosaveEnabled) {
			CMainFrame::theInstance->StartAutosaveTimer(autosaveFreq);
		}
		else {
			CMainFrame::theInstance->StopAutosaveTimer();
		}
		CGMEDoc::theInstance->ResetAllViews();
	}
}

LONG GetRegKey(HKEY key, LPCTSTR subkey, LPTSTR retdata)
{
	HKEY hKey;
    LONG lResult = RegOpenKeyEx(key, subkey, 0, KEY_QUERY_VALUE, &hKey); 
  
    if( lResult == ERROR_SUCCESS)
	{
         long lDataSize = MAX_PATH;
		TCHAR data[MAX_PATH];
  
		RegQueryValue( hKey, NULL, data, &lDataSize);
		lstrcpy( retdata,data);
		RegCloseKey( hKey);
    }
  
    return lResult;
}
  
HINSTANCE GotoURL(LPCTSTR url, int showcmd)
{
	TCHAR key[MAX_PATH + MAX_PATH];
  
    // First try ShellExecute()
    HINSTANCE hResult = ShellExecute( NULL, _T("open"), url, NULL,NULL, showcmd);
    //HINSTANCE hResult;
    // If it failed, get the .htm regkey and lookup the program
    if((UINT)hResult <= HINSTANCE_ERROR)
	{
		if( GetRegKey( HKEY_CLASSES_ROOT, _T(".htm"), key) == ERROR_SUCCESS)
		{
             lstrcat( key, _T("\\shell\\open\\command")); 
  
             if( GetRegKey( HKEY_CLASSES_ROOT,key,key) == ERROR_SUCCESS)
			 {
				TCHAR *pos;
                 pos = _tcsstr( key, _T("\"%1\"")); 
  
                 if( pos == NULL)
				 {
					// No quotes found
                    pos = strstr( key, _T("%1")); // Check for % 1, without quotes
                    if( pos == NULL)    // No  parameter at all...
                         pos = key+lstrlen( key)-1;
                     else
                         *pos = '\0';    //  Remove the parameter
                 }
                 else
                     *pos = '\0';
					// Remove the parameter
  
                 lstrcat(pos, _T(" "));
                 lstrcat(pos, url);
  
                 hResult = (HINSTANCE)WinExec( key,showcmd);
             }
         }
	}
  
     return hResult;
}

/////////////////////////////////////////////////////////////////////////////
// CGMEApp message handlers

// *******************************************************************************
// *******************************************************************************
//								FILE
// *******************************************************************************
// *******************************************************************************


void CGMEApp::OnFileOpen() 
{
	CMgaOpenDlg dlg(CMgaOpenDlg::OpenDialog);
	CString conn = dlg.AskConnectionString(false);

	CGMEEventLogger::LogGMEEvent("CGMEApp::OnFileOpen "+conn+"\r\n");

	if( conn.IsEmpty() )
		return;

	CWaitCursor wait;

	if( mgaProject != NULL )
		CloseProject();

	OpenProject(conn);

}


#define PROJECT_STATUS_CHANGED 4

BOOL CGMEApp::SaveAllModified() 
{
	if(mgaProject != NULL && (proj_type_is_mga||proj_type_is_xmlbackend)) {
		long l;
		COMTHROW(mgaProject->get_ProjectStatus(&l));
		int ret;
		if(!(l & PROJECT_STATUS_CHANGED)) ret = IDNO;
		else ret = AfxMessageBox("Save project '" + projectName + "'?",  MB_YESNOCANCEL);
		if(ret == IDCANCEL) return FALSE;
		else if(ret == IDNO) {
			abort_on_close = true;
			OnFileAbortProject();
		}
		else return SafeCloseProject();
	}
	return TRUE;
}

int CGMEApp::ExitInstance() 
{
	CloseProject(false);
	return CWinApp::ExitInstance();
}

void CGMEApp::OnFileNew() 
{
	CGMEEventLogger::LogGMEEvent("CGMEApp::OnFileNew\r\n");

	MSGTRY	{
		CString metaname;
		CString dataconn;
		CMgaOpenDlg dlg(CMgaOpenDlg::NewDialog);

		CComObjPtr<IMgaLauncher> launcher;
		COMTHROW( launcher.CoCreateInstance(CComBSTR(L"Mga.MgaLauncher")) );

	meta_label:
		HRESULT hr = launcher->MetaDlg(METADLG_NONE);
		if( hr == S_FALSE )
			return;
		COMTHROW( hr );

		metaname.Empty();
		COMTHROW( launcher->get_ParadigmName(PutOut(metaname)) );

		dataconn = dlg.AskConnectionString(false);

		if( dlg.pressed_back )
			goto meta_label;

		if( dataconn.IsEmpty() )
			return;

		CWaitCursor wait;

		if( mgaProject != NULL )
			CloseProject();

		CreateProject(metaname, dataconn);

		if (mgaProject != NULL && (proj_type_is_mga||proj_type_is_xmlbackend)) {
			OnFileSave();
		}
	}
	MSGCATCH("Error creating new project",;)

}

BOOL CGMEApp::OnOpenRecentProject(UINT nID)
{
	ASSERT_VALID(this);

	ASSERT(nID >= ID_FILE_MRU_PRJ1);
	ASSERT(nID < ID_FILE_MRU_PRJ1 + (UINT)m_RecentProjectList.GetSize());

	int nIndex = nID - ID_FILE_MRU_PRJ1;
	CString conn = m_RecentProjectList[nIndex];

	ASSERT(conn.GetLength() != 0);

	CGMEEventLogger::LogGMEEvent("CGMEApp::OnOpenRecentProject "+conn+"\r\n");

	CWaitCursor wait;

	if( mgaProject != NULL )
		CloseProject();

	OpenProject(conn);

	return TRUE;
}


bool CGMEApp::SafeCloseProject() {
// In case of an MGA file, try to save it first to find out 
	abort_on_close = false;
	if(mgaProject != NULL && (proj_type_is_mga||proj_type_is_xmlbackend)) {
		HRESULT hr = mgaProject->Save(NULL);
		if(hr != S_OK) {
			AfxMessageBox("ERROR: Could not save project\nCheck access permissions");
			return false;
		}
		abort_on_close = true;
	}

	BeginWaitCursor();
	if(CGMEDoc::theInstance)
		CGMEDoc::theInstance->OnCloseDocument();
	EndWaitCursor();
	return true;
}

void CGMEApp::OnFileCloseproject() 
{
	CGMEEventLogger::LogGMEEvent("CGMEApp::OnFileCloseproject\r\n");
	SafeCloseProject();
}


void CGMEApp::OnFileSaveAs() {
	CMgaOpenDlg dlg(CMgaOpenDlg::SaveAsDialog);
	CString conn = dlg.AskMGAConnectionString();

	CGMEEventLogger::LogGMEEvent("CGMEApp::OnFileSaveAs "+conn+"\r\n");

	if( conn.IsEmpty() )
		return;
	BeginWaitCursor();
	SaveProject(conn);
	EndWaitCursor();
}

void CGMEApp::OnFileSave() 
{
	CGMEEventLogger::LogGMEEvent("CGMEApp::OnFileSave\r\n");
	BeginWaitCursor();
	SaveProject("");
	EndWaitCursor();
}

void CGMEApp::OnFileAbortProject() 
{
	CGMEEventLogger::LogGMEEvent("CGMEApp::OnFileAbortProject\r\n");
	if(!mgaProject) return;
	long l;
	COMTHROW(mgaProject->get_ProjectStatus(&l));
	if(!abort_on_close && (l & PROJECT_STATUS_CHANGED) &&
		AfxMessageBox("Discard edits to project " + projectName + "?", 
		MB_OKCANCEL) == IDCANCEL) {
		return;
	}
	abort_on_close = true;

	BeginWaitCursor();
	if(CGMEDoc::theInstance)
		CGMEDoc::theInstance->OnCloseDocument(true);
	EndWaitCursor();
}


void CGMEApp::OnFileExportxml() 
{
	CGMEEventLogger::LogGMEEvent("CGMEApp::OnFileExportxml ");
	MSGTRY
	{
		CComPtr<IMgaDumper> dumper;
		COMTHROW( dumper.CoCreateInstance(L"Mga.MgaDumper") );
		ASSERT( dumper != NULL );

		CFileDialog dlg(FALSE, "xme", NULL,
			OFN_EXPLORER | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
			"Exported Files (*.xme)|*.xme|GME 1.x XML Format (*.xml)|*.xml|All Files (*.*)|*.*||");
		if( dlg.DoModal() != IDOK )
		{
			CGMEEventLogger::LogGMEEvent("Canceled\r\n");
			return;
		}
		CGMEEventLogger::LogGMEEvent(dlg.GetPathName()+"\r\n");

		CWaitCursor wait;
		if(dlg.m_ofn.nFilterIndex == 2) {
			AfxMessageBox(
				"WARNING Saving in GME 1.x XML format.\n"
				"Libraries are converted to normal model data,\n"
				"thus resulting XML file may need some editing\n"
				"to avoid paradigm violations on import");
			COMTHROW(dumper->put_FormatVersion(0));
		}
		COMTHROW( dumper->DumpProject(theApp.mgaProject,PutInBstr(dlg.GetPathName())) );

		AfxMessageBox("The XML file was successfully exported.");
	}
	MSGCATCH("Error while generating XML file",;)
}


void CGMEApp::OnFileImportxml() 
{
	CGMEEventLogger::LogGMEEvent("CGMEApp::OnFileImportxml ");

	bool keep_on( true); // if true then keep working even after a failed import: try to apply an xslt script
	CString file_name;
	CString new_file_name = "";

	while (keep_on)
	{
		keep_on = false;
		MSGTRY
		{
			CComPtr<IMgaParser> parser;
			COMTHROW( parser.CoCreateInstance(L"Mga.MgaParser") );
			ASSERT( parser != NULL );

			CFileDialog dlg(TRUE, "xme", (LPCTSTR) new_file_name,
				OFN_EXPLORER | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT |
				OFN_FILEMUSTEXIST,
				"GME Exported Files (*.xme;*.xml)|*.xme; *.xml|All Files (*.*)|*.*||");
			if( dlg.DoModal() != IDOK )
			{
				CGMEEventLogger::LogGMEEvent("Cancelled\r\n");
				return;
			}
			CGMEEventLogger::LogGMEEvent(dlg.GetPathName()+"\r\n");

			if (dlg.GetFileExt().CompareNoCase("xml") == 0 ) {
				AfxMessageBox(
						"Newer versions of GME use the \".xme.\" filename extension\n"
						"for exported XML data files.\n"
						"Please, rename your existing files to avoid further problems!\n", 
						MB_OK | MB_ICONINFORMATION);
			}

			bool newproject = !mgaProject;
			if (newproject) {
				CString dataconn;
				COMTRY {
					CComBstrObj paradigm, parversion, basename, version;
					CComVariant parguid;

					COMTHROW( parser->GetXMLInfo(PutInBstr(dlg.GetPathName()), PutOut(paradigm), PutOut(parversion), &parguid, PutOut(basename), PutOut(version)) );

					CMgaOpenDlg opdlg(CMgaOpenDlg::ImportDialog);
					opdlg.filenamehint = basename;
					dataconn = opdlg.AskConnectionString(false);
					if (dataconn.IsEmpty()) {
					   return;
					}

					{
						CComPtr<IMgaRegistrar> reg;
						COMTHROW( reg.CoCreateInstance(L"Mga.MgaRegistrar") );
						CComBstrObj conn;
						HRESULT h1 = reg->QueryParadigm(paradigm, PutOut(conn), &parguid, REGACCESS_PRIORITY);
						CComVariant pg2;
						conn.Empty();
						HRESULT h2 = reg->QueryParadigm(paradigm, PutOut(conn), &pg2, REGACCESS_PRIORITY);
						char buf[300];
						if(h2 != S_OK) {
							ASSERT(h1 != S_OK);
							CString msg = "Could not find paradigm paradigm '" + CString(paradigm) + "'\n" 
									" (Eg.: In GME3 the MetaGME2000 paradigm was renamed to MetaGME)\n"
									"Do you want to import with an other registered paradigm ?";
							if (AfxMessageBox(msg ,MB_OKCANCEL) == IDOK) {	
								CComObjPtr<IMgaLauncher> launcher;
								COMTHROW( launcher.CoCreateInstance(CComBSTR(L"Mga.MgaLauncher")) );
								if (SUCCEEDED(launcher->MetaDlg(METADLG_NONE))) {
									// parguid = true;
									parguid.Clear();
									paradigm.Empty();
									COMTHROW( launcher->get_ParadigmName(PutOut(paradigm)) );
								}
								else {
									return;   // safe before create
								}
							}
							else {
								return;   // safe before create
							}
						}
						else {
							CComBstrObj parguid1, parguid2;
							GUID gg;

							CopyTo(parguid,gg);
							CopyTo(gg, parguid1);

							CopyTo(pg2,gg);
							CopyTo(gg, parguid2);

							if(h1 != S_OK) {
								sprintf(buf, "Could not locate paradigm %s\nVersion ID: %s\n"
											 "Do you want to upgrade to the current version instead?\nCurrent ID: %s", 
											 PutInCString(paradigm), PutInCString(parguid1), PutInCString(parguid2));
											 if(AfxMessageBox(buf,MB_OKCANCEL | MB_ICONQUESTION) == IDOK) {
												parguid = pg2;
											 }
											 else {
												AfxMessageBox("Import canceled");
												return; // safe before create
											 }	

							}
							else if(parguid1.Compare(parguid2)) {
								sprintf(buf, "This model was exported using paradigm %s\nVersion ID: %s\n"
											 "Do you want to upgrade to the current version?\nCurrent ID: %s", 
											 PutInCString(paradigm), PutInCString(parguid1), PutInCString(parguid2));
											 int answer = AfxMessageBox(buf,MB_YESNOCANCEL | MB_ICONQUESTION);
											 if(answer == IDYES) {
												parguid = pg2;
											 }
											 else if(answer == IDCANCEL) {
												AfxMessageBox("Import canceled");
												return;  // safe before create
											 }
							}
						}
					}
					COMTHROW( mgaProject.CoCreateInstance(L"Mga.MgaProject") );
#pragma warning(disable: 4310) // cast truncates constant value
					COMTHROW( mgaProject->EnableAutoAddOns(VARIANT_TRUE));
#pragma warning(default: 4310) // cast truncates constant value
					HRESULT hr = mgaProject->CreateEx(PutInBstr(dataconn), PutInBstr(paradigm), parguid);
					if(hr == E_MGA_PARADIGM_NOTREG || hr == E_MGA_PARADIGM_INVALID) {
						char buf[300];
						CComBstrObj parguid1;
						GUID gg;
						CopyTo(parguid,gg);
						CopyTo(gg, parguid1);
						sprintf(buf, "Could not open paradigm %s\nVersion ID: %s", 
							PutInCString(paradigm), PutInCString(parguid1));

						AfxMessageBox(buf);
					}
					if(hr == E_MGA_COMPONENT_ERROR) {
						AfxMessageBox("ERROR: Some automatic addon components could not start up\n");
					}
					COMTHROW(hr);
					AfterOpenOrCreateProject(dataconn); 
				} catch(hresult_exception &e) {
					CloseProject();
					DisplayError("Could not create the project", e.hr); 
					throw;
				}
			}

			UpdateProjectName();

			CWaitCursor wait;
			if(mgaConstMgr) COMTHROW(mgaConstMgr->Enable(false));

			keep_on = true;
			file_name = dlg.GetPathName();
			COMTHROW(parser->ParseProject(theApp.mgaProject,PutInBstr(dlg.GetPathName())) );

			if(newproject && (proj_type_is_mga||proj_type_is_xmlbackend)) {
				OnFileSave();
			}
			AfxMessageBox("The XML file was successfully imported.");
			keep_on = false;
		}
		MSGCATCH("Error importing XML file",;)

		if ( keep_on)
		{
			keep_on = false;
			int answer = AfxMessageBox("Do you want to apply an XSLT script on the .xme file?",MB_YESNO | MB_ICONQUESTION);
			if( answer == IDYES) 
			{
				try
				{
					CComObjPtr<IMgaXsltFileSel> xslt;
					COMTHROW( xslt.CoCreateInstance( L"Mga.MgaXsltFileSel"));
					ASSERT( xslt != NULL );

					CComBstrObj result;
					HRESULT hr = xslt->StartXslt( PutInBstr( file_name.GetBuffer( file_name.GetLength())), PutOut(result));
					if ( hr == S_OK)
					{
						CopyTo( result, new_file_name);
						AfxMessageBox("Continuing to Import XML...");
						keep_on = true;
					}
				} 
				catch( ...)
				{ 
					keep_on = false;
				}
			}
		}
	} // while keep_on

	if (mgaConstMgr) COMTHROW(mgaConstMgr->Enable(true));
}



void CGMEApp::OnFileXMLUpdate() 
{
	CGMEEventLogger::LogGMEEvent("CGMEApp::OnFileXMLUpdate\r\n");
    ASSERT(mgaProject);
    ASSERT(mgaMetaProject);

	TCHAR xmlname[MAX_PATH];
	GetTempFileName(".", "XEX",0, xmlname);
	
	if(currentConnection.Find("MGA=") != 0) {
		AfxMessageBox("Function is available only for .mga models");
	}

	CString fname = currentConnection.Mid(4);
	CString backupname;

	MSGTRY
	{
		CWaitCursor wait;
		CComBstrObj parname;
		COMTHROW( mgaMetaProject->get_Name(PutOut(parname)) );
		CComBstrObj metaconn;

		CComBstrObj currentguid;
		{
			CComVariant parguid;
			COMTHROW( mgaMetaProject->get_GUID(&parguid) );

			CComPtr<IMgaRegistrar> reg;
			COMTHROW( reg.CoCreateInstance(L"Mga.MgaRegistrar") );
			CComVariant pg2;

			COMTHROW(reg->QueryParadigm(parname, PutOut(metaconn), &pg2, REGACCESS_PRIORITY));

			CComBstrObj parguid1;
			GUID gg;
			CopyTo(parguid,gg);
			CopyTo(gg, parguid1);

			CopyTo(pg2,gg);
			CopyTo(gg, currentguid);

			if(!parguid1.Compare(currentguid)) {
				char buf[200];
				sprintf(buf, "There is no need to upgrade this model\nIts Meta Version ID is the current ID\nCurrent ID: %s", 
					PutInCString(currentguid));
				AfxMessageBox(buf);
				return;
			}
		}

		CComPtr<IMgaDumper> dumper;
		COMTHROW( dumper.CoCreateInstance(L"Mga.MgaDumper") );
		ASSERT( dumper != NULL );

		COMTHROW( dumper->DumpProject(theApp.mgaProject, PutInBstr(xmlname)) );


		SafeCloseProject();
		ASSERT(!mgaProject);

		backupname = fname;
		int p = backupname.ReverseFind('.');
		if(!p || backupname.Find('\\',p) != -1) p = backupname.GetLength();
		backupname.Insert(p,"-backup");
		DeleteFile(backupname);
		if(!MoveFile(fname, backupname)) {
			backupname = fname;
			char buf[300];
			sprintf( buf, "Could not save original file '%s' to '%s'", fname, backupname); 
			AfxMessageBox(buf);
			COMTHROW(E_NOTFOUND);
		}



		CreateProject(PutInCString(parname), currentConnection);

		if(!mgaProject || !mgaMetaProject) {
			AfxMessageBox("Error creating project");
			return;
		}

		UpdateComponentLists();
		ChangedProjectConnStrings();

		CComPtr<IMgaParser> parser;
		COMTHROW( parser.CoCreateInstance(L"Mga.MgaParser") );
		ASSERT( parser != NULL );
	    if(mgaConstMgr) COMTHROW(mgaConstMgr->Enable(false));
	    COMTHROW(parser->ParseProject(mgaProject, PutInBstr(xmlname)) );
		{
			char buf[200];
			sprintf(buf, "The model has been updated\nCurrent ID: %s\nThe original model has been saved to %s", 
					PutInCString(currentguid), backupname);
			AfxMessageBox(buf);
		}
	}
	catch(hresult_exception &e)	{
		char buf[200];
		if(backupname.IsEmpty()) {
			sprintf(buf, "The upgrade failed: %ld\nThe model has not been closed", e.hr);
			AfxMessageBox(buf);
		}
		else {
			if(backupname.Compare(fname)) {
				if(MoveFile(backupname, fname)) backupname = fname;
			}
			sprintf(buf, "The upgrade failed: %ld\nThe original model is in file %s", e.hr, backupname);
			AfxMessageBox(buf);
		}
	}

    if (mgaConstMgr) COMTHROW(mgaConstMgr->Enable(true));
}



void CGMEApp::OnFileRegcomponents() 
{
	CGMEEventLogger::LogGMEEvent("CGMEApp::OnFileRegcomponents ");
	MSGTRY
	{
		CComObjPtr<IMgaLauncher> launcher;
		COMTHROW( launcher.CoCreateInstance(L"Mga.MgaLauncher") );
		COMTHROW( launcher->put_ParadigmName(PutInBstr(guiMetaProject->name)));
		COMTHROW( launcher->put_ComponentType(COMPONENTTYPE_ALL) );

		ATLASSERT(mgaProject);
		CComBSTR runningcomps;
		{
			CComPtr<IMgaComponents> comps;
			COMTHROW(mgaProject->get_AddOnComponents(&comps));
			MGACOLL_ITERATE(IMgaComponent, comps) {
				CComQIPtr<IMgaComponentEx> compx = MGACOLL_ITER;
				CComBSTR p;
				if(compx) COMTHROW(compx->get_ComponentProgID(&p));
				else COMTHROW(MGACOLL_ITER->get_ComponentName(&p));
				if(runningcomps) runningcomps += " ";
				runningcomps += p;
			}
			MGACOLL_ITERATE_END;
		}
		COMTHROW(launcher->put_Parameter(CComVariant(runningcomps)));

		CGMEEventLogger::LogGMEEvent(CString(runningcomps)+"\r\n");

		COMTHROW( launcher->ComponentDlg(COMPONENTDLG_INTERP));
		UpdateComponentLists(true);
	}
	MSGCATCH("Error while trying to register the interpreter",;)
}

void CGMEApp::OnFileSettings() 
{
	CGMEEventLogger::LogGMEEvent("CGMEApp::OnFileSettings\r\n");
	MSGTRY
	{
		CComObjPtr<IMgaLauncher> launcher;
		COMTHROW( launcher.CoCreateInstance(L"Mga.MgaLauncher") );
		COMTHROW( launcher->GmeDlg());
	}
	MSGCATCH("Error while trying to get GME settings",;)
	GetSettings();
}

void CGMEApp::OnFileClearLocks() 
{
	if( mgaProject != NULL || mgaMetaProject != NULL )
		return;

	MSGTRY
	{
		CMgaOpenDlg dlg(CMgaOpenDlg::ClearLocksDialog);
		CString conn = dlg.AskConnectionString(false);

		if( conn.IsEmpty() )
			return;

		CWaitCursor wait;

		CComObjPtr<IMgaProject> project;
		COMTHROW( project.CoCreateInstance(OLESTR("MGA.MgaProject")) );
		ASSERT( project != NULL );
#pragma warning(disable: 4310) // cast truncates constant value
		COMTHROW( project->CheckLocks(PutInBstr(conn), VARIANT_TRUE) );
#pragma warning(default: 4310) // cast truncates constant value

		AfxMessageBox("Database locks are cleared");
	}
	MSGCATCH("Error while clearing locks in database",;)
}

void CGMEApp::OnHelpContents() 
{
	CGMEEventLogger::LogGMEEvent("CGMEApp::OnHelpContents\r\n");

	MSGTRY {
		CComObjPtr<IMgaLauncher> launcher;
		COMTHROW( launcher.CoCreateInstance(L"Mga.MgaLauncher") );
		COMTHROW( launcher->ShowHelp(NULL) );
	}
	MSGCATCH("Error while showing help contents.",;)
}

void CGMEApp::OnFileCheckall() 
{
	CGMEEventLogger::LogGMEEvent("CGMEApp::OnFileCheckall\r\n");
	ASSERT(mgaConstMgr);
	if(!mgaConstMgr) return;
	// message boxes displayed from constraint manager if in interactive mode
	mgaConstMgr->ObjectsInvokeEx(mgaProject, NULL, NULL, NULL);
}

void CGMEApp::OnFileDisplayConstraints() 
{
	CGMEEventLogger::LogGMEEvent("CGMEApp::OnFileDisplayConstraints\r\n");
	ASSERT(mgaConstMgr);
	mgaConstMgr->ObjectsInvokeEx(mgaProject, NULL, NULL, CONSTMGR_SHOW_CONSTRAINTS);
	
}



void CGMEApp::OnFileRegparadigms() 
{
	CGMEEventLogger::LogGMEEvent("CGMEApp::OnFileRegparadigms\r\n");
	MSGTRY
	{
		CComPtr<IMgaLauncher> launcher;
		COMTHROW( launcher.CoCreateInstance(L"Mga.MgaLauncher") );

		while(1) {
			HRESULT hr = launcher->MetaDlg(METADLG_PARREG);
			if( hr == S_FALSE )	return;

			COMTHROW( launcher->put_ComponentType(COMPONENTTYPE_ALL) );

			bool workonrunningparadigm = false;
			if(guiMetaProject) {
				CComBstrObj metaname;
				COMTHROW( launcher->get_ParadigmName(PutOut(metaname)) );
				if(metaname == PutInBstr(guiMetaProject->name)) workonrunningparadigm = true;
			}

			if(workonrunningparadigm) {
				ATLASSERT(mgaProject);
				CComBSTR runningcomps;
				CComPtr<IMgaComponents> comps;
				COMTHROW(mgaProject->get_AddOnComponents(&comps));
				MGACOLL_ITERATE(IMgaComponent, comps) {
					CComQIPtr<IMgaComponentEx> compx = MGACOLL_ITER;
					CComBSTR p;
					if(compx) COMTHROW(compx->get_ComponentProgID(&p));
					else COMTHROW(MGACOLL_ITER->get_ComponentName(&p));
					if(runningcomps) runningcomps += " ";
					runningcomps += p;
				}
				MGACOLL_ITERATE_END;
				COMTHROW(launcher->put_Parameter(CComVariant(runningcomps)));
			}

			COMTHROW( launcher->ComponentDlg(COMPONENTDLG_INTERP));

			if(workonrunningparadigm) UpdateComponentLists(true);
		}
	} MSGCATCH("Error registering paradigms", ;);
}


// *******************************************************************************

void CGMEApp::OnUpdateFileNew(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(guiMetaProject == NULL);
}

void CGMEApp::OnUpdateFileOpen(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(guiMetaProject == NULL);
}

void CGMEApp::OnUpdateFileCloseproject(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(guiMetaProject != NULL);
}

void CGMEApp::OnUpdateFileSave(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(mgaProject != NULL && (proj_type_is_mga||proj_type_is_xmlbackend));
}

void CGMEApp::OnUpdateFileSaveAs(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(mgaProject != NULL && proj_type_is_mga);
}

void CGMEApp::OnUpdateFileAbortProject(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(mgaProject != NULL && proj_type_is_mga);
}

void CGMEApp::OnUpdateFileExportxml(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(guiMetaProject != NULL);
}

void CGMEApp::OnUpdateFileXMLUpdate(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(mgaProject != NULL && proj_type_is_mga);
}

void CGMEApp::OnUpdateFileCheckall(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(mgaConstMgr != NULL);
}

void CGMEApp::OnUpdateFileDisplayConstraints(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(mgaConstMgr != NULL);	
	
}

void CGMEApp::OnUpdateFileRegcomponents(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(guiMetaProject != NULL);
}

void CGMEApp::OnUpdateRecentProjectMenu(CCmdUI* pCmdUI)
{
	ASSERT_VALID(this);
	m_RecentProjectList.UpdateMenu(pCmdUI,guiMetaProject == NULL);
}


// *******************************************************************************
// *******************************************************************************
//								EDIT
// *******************************************************************************
// *******************************************************************************


void CGMEApp::OnEditProjectproperties() 
{
	CGMEEventLogger::LogGMEEvent("CGMEApp::OnEditProjectproperties " + projectName +"\r\n");
	CProjectPropertiesDlg dlg;
	if(dlg.DoModal() == IDOK) {
		if(CGMEDoc::theInstance)
			CGMEDoc::theInstance->SetTitle(projectName);
		CMainFrame::theInstance->UpdateTitle(projectName);
	}
}


void CGMEApp::OnEditUndo() 
{
	CGMEEventLogger::LogGMEEvent("CGMEApp::OnEditUndo\r\n");
	mgaProject->Undo();
}

void CGMEApp::OnEditRedo() 
{
	CGMEEventLogger::LogGMEEvent("CGMEApp::OnEditRedo\r\n");
	mgaProject->Redo();
}

void CGMEApp::OnEditClearUndo() 
{
	CGMEEventLogger::LogGMEEvent("CGMEApp::OnEditClearUndo\r\n");
	if( mgaProject == NULL )
		return;

	if(AfxMessageBox("You are about to loose all Undo/Redo information. Proceed?",MB_YESNO | MB_ICONQUESTION) == IDYES) {
		MSGTRY
		{
			COMTHROW( mgaProject->FlushUndoQueue() );
		}
		MSGCATCH("Error while clearing the undo queue",;)
	}
}


// *******************************************************************************

void CGMEApp::OnUpdateEditUndo(CCmdUI* pCmdUI) 
{
	if(guiMetaProject != NULL) {
		short undoSize;
		short redoSize;
		mgaProject->UndoRedoSize(&undoSize,&redoSize);
		pCmdUI->Enable(undoSize > 0);
	}
	else
		pCmdUI->Enable(FALSE);
}

void CGMEApp::OnUpdateEditRedo(CCmdUI* pCmdUI) 
{
	if(guiMetaProject != NULL) {
		short undoSize;
		short redoSize;
		mgaProject->UndoRedoSize(&undoSize,&redoSize);
		pCmdUI->Enable(redoSize > 0);
	}
	else
		pCmdUI->Enable(FALSE);
}

void CGMEApp::OnUpdateEditClearUndo(CCmdUI* pCmdUI) 
{
	if(mgaProject != NULL) {
		short undoSize;
		short redoSize;
		mgaProject->UndoRedoSize(&undoSize,&redoSize);
		pCmdUI->Enable(undoSize > 0);
	}
	else
		pCmdUI->Enable(FALSE);
}

void CGMEApp::OnUpdateEditProjectproperties(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(CGMEDoc::theInstance != 0);
}



/*
void CGMEApp::OnUpdateFileRunplugin1(CCmdUI* pCmdUI) 
{
	
	CMenu *filemenu = pCmdUI->m_pMenu;
	UINT idx = pCmdUI->m_nIndex;
if(idx == 0) return;
	CString label;
	ASSERT(filemenu);
	filemenu->GetMenuString(idx,label,MF_BYPOSITION);
	filemenu->DeleteMenu(idx,MF_BYPOSITION);
	CMenu pluginmenu;
	pluginmenu.CreatePopupMenu();
	pluginmenu.GetMenuItemID
	for(int i = 0; i < comps.GetSize(); ++i)	{
			pluginmenu.AppendMenu(MF_ENABLED, pCmdUI->m_nID + i,comps[i]);
	}
	filemenu->InsertMenu(idx,
						comps.GetSize() ? MF_BYPOSITION|MF_POPUP|MF_ENABLED: MF_BYPOSITION|MF_POPUP|MF_GRAYED,
						(UINT)pluginmenu.Detach(),label);
	
}
*/

void CGMEApp::OnRunPlugin(UINT nID) {
	CGMEEventLogger::LogGMEEvent("CGMEApp::OnRunPlugin "+plugins[nID - ID_FILE_RUNPLUGIN1]+"\r\n");

	// Focus must be killed to flush ObjectInspector and Browser
	::SetFocus(NULL);

	RunComponent(plugins[nID - ID_FILE_RUNPLUGIN1]);
}

void CGMEApp::OnRunInterpreter(UINT nID) {
	CGMEEventLogger::LogGMEEvent("CGMEApp::OnRunInterpreter "+interpreters[nID - ID_FILE_INTERPRET1]+"\r\n");

	// Focus must be killed to flush ObjectInspector and Browser
	::SetFocus(NULL);

	RunComponent(interpreters[nID - ID_FILE_INTERPRET1]);
}



void CGMEApp::RunComponent(const CString &compname)
{

	CComPtr<IMgaLauncher> launcher;
	launcher.CoCreateInstance(CComBSTR(L"Mga.MgaLauncher") );
	if(!launcher) {
		AfxMessageBox("Cannot start up component launcher");
	}
	else {
		CComPtr<IMgaFCO> focus;
		CComPtr<IMgaFCOs> selfcos;
		COMTHROW(selfcos.CoCreateInstance(OLESTR("Mga.MgaFCOs")));
		CMDIChildWnd *pChild  = CMainFrame::theInstance->MDIGetActive();
		if (pChild) {
			CGMEView *view = (CGMEView*)pChild->GetActiveView();
			if (view) {
				COMTHROW(view->currentModel.QueryInterface(&focus));
				POSITION pos = view->selected.GetHeadPosition();
				while (pos) {
					CGuiFco *gfco = view->selected.GetNext(pos);
					COMTHROW(selfcos->Append(gfco->mgaFco));
				}
			}
		}

		if(theApp.bNoProtect) COMTHROW( launcher->put_Parameter(CComVariant(true)));
		if(launcher->RunComponent(PutInBstr(compname), mgaProject, focus, selfcos, GME_MENU_START) != S_OK) {
			AfxMessageBox("Component execution failed");
		}
	}
}

class CGmePrintSetup : public CPrintDialog
{
public:
	enum { IDD = IDD_PRINT_DIALOG  };
	CGmePrintSetup() : CPrintDialog(true, 0, NULL) {}
};

void CGMEApp::OnUniquePrintSetup()
{
	CGmePrintSetup setup;
	setup.m_pd.Flags =	PD_PRINTSETUP |  // actually the current aspect
								PD_ENABLESETUPTEMPLATE |
								PD_ENABLEPRINTHOOK | PD_ENABLESETUPHOOK ;
	setup.m_pd.hInstance = AfxGetInstanceHandle();
	setup.m_pd.lpSetupTemplateName = MAKEINTRESOURCE(PRNSETUPDLGORD);
	DoPrintDialog(&setup);
}
