// MgaFolder.h : Declaration of the CMgaFolder

#ifndef __MGAFOLDER_H_
#define __MGAFOLDER_H_

#include "resource.h"       // main symbols
#include "MgaFCO.h"

/////////////////////////////////////////////////////////////////////////////

// CMgaContainer


//##ModelId=3C5AA08F0116
template <class T> 
class ATL_NO_VTABLE IMgaContainerImpl : 	public T {
public:

	//##ModelId=3C5AA08F012B
	STDMETHOD(GetChildrenOfKind)(BSTR kn, IMgaFCOs **pVal) { return inFCO->GetChildrenOfKind(kn, pVal); }
	//##ModelId=3C5AA08F013E
	STDMETHOD(GetDescendantFCOs)(IMgaFilter* filt, IMgaFCOs **pVal) { 
													return inFCO->GetDescendantFCOs(filt, pVal); };
	//##ModelId=3C5AA08F0149
	STDMETHOD(get_ChildFCOs)(IMgaFCOs ** pVal)    { return inFCO->get_ChildFCOs(pVal); };
	//##ModelId=3C5AA08F0154
	STDMETHOD(get_ChildFCO)(BSTR n,IMgaFCO**pVal) { return inFCO->get_ChildFCO(n, pVal); };


};


// CMgaFolder
//##ModelId=3C5AA08F01CA
class ATL_NO_VTABLE CMgaFolder : 
	public CComCoClass<CMgaFolder, &CLSID_MgaFolder>,
	public IMgaContainerImpl < IMgaFCOImpl <CComObjectRootEx<CComSingleThreadModel> ,
											 IDispatchImpl<IMgaFolder, &IID_IMgaFolder, &LIBID_MGALib> > >,
	public ISupportErrorInfoImpl<&IID_IMgaFolder>
{
public:

	//##ModelId=3C5AA08F0262
DECLARE_ONLY_AGGREGATEABLE(_CoClass);

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CMgaFolder)
	COM_INTERFACE_ENTRY(IMgaFolder)
	COM_INTERFACE_ENTRY_IID(IID_IMgaObject,IMgaFolder)
//	COM_INTERFACE_ENTRY_IID(IID_IMgaContainer,IMgaFolder)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY_IID(IID_ISupportErrorInfo, IMyErrorInfoBase)
END_COM_MAP()

// IMgaFolder
	//##ModelId=3C5AA08F026B
	STDMETHOD(DeriveRootObject)(IMgaFCO* base, VARIANT_BOOL instance, IMgaFCO **nobj) {
											return inFCO->DeriveFCO(base, NULL, instance, nobj); 	}
	//##ModelId=3C5AA08F0280
	STDMETHOD(CreateRootObject)(IMgaMetaFCO* meta, IMgaFCO **nobj) {
											return inFCO->CreateRootObject(meta,nobj); }
	//##ModelId=3C5AA08F0294
	STDMETHOD(CreateFolder)(IMgaMetaFolder *meta, IMgaFolder **nf) {
											return inFCO->CreateFolder(meta, nf); }
	//##ModelId=3C5AA08F02A8
	STDMETHOD(get_ChildFolders)(IMgaFolders **pVal) {
											return inFCO->get_ChildFolders(pVal); }
	//##ModelId=3C5AA08F02BB
	STDMETHOD(get_ParentFolder)(IMgaFolder **pVal) { return 
		inFCO->GetParent(reinterpret_cast<IMgaContainer **>(pVal),NULL); }

	//##ModelId=3C5AA08F02C5
	STDMETHOD(get_MetaFolder)(IMgaMetaFolder **pVal) { return inFCO->get_MetaFolder(pVal); } 
	//##ModelId=3C5AA08F02D0
	STDMETHOD(CopyFCOs)(IMgaFCOs *list, IMgaFCOs **objs) { return inFCO->CopyFCOs(list, NULL, objs); } 
	//##ModelId=3C5AA08F02E4
	STDMETHOD(MoveFCOs)(IMgaFCOs *list, IMgaFCOs **objs) { return inFCO->MoveFCOs(list, NULL, objs); } 
	//##ModelId=3C5AA08F02D0
	STDMETHOD(CopyFolders)(IMgaFolders *list, IMgaFolders **objs) { return inFCO->CopyFolders(list, /*NULL,*/ objs); } 
	//##ModelId=3C5AA08F02E4
	STDMETHOD(MoveFolders)(IMgaFolders *list, IMgaFolders **objs) { return inFCO->MoveFolders(list, /*NULL,*/ objs); } 
	//STDMETHOD(MoveFCOsAndFolders)(IMgaFolders *list, IMgaFCOs *list2, IMgaFolders **objs, IMgaFCOs **objs2) { return inFCO->MoveFCOsAndFolders(list, list2, objs, objs2); } 
	STDMETHOD(RefreshParent)(IMgaFolder *parent) { return inFCO->RefreshParent( parent); }

	//##ModelId=3C5AA08F0301
	STDMETHOD(AttachLibrary)(BSTR libname, IMgaFolder **nf) 
												{ return inFCO->AttachLibrary(libname, nf); }
	//##ModelId=3C5AA08F0316
	STDMETHOD(RefreshLibrary)(BSTR libname) 
												{ return inFCO->RefreshLibrary(libname); }
	//##ModelId=3C5AA08F0329
	STDMETHOD(get_LibraryName)(BSTR *libname) 
												{ return inFCO->get_LibraryName(libname); }
	//##ModelId=3C5AA08F0333
	STDMETHOD(put_LibraryName)(BSTR libname) 
												{ return inFCO->put_LibraryName(libname); }
	//##ModelId=3C5AA08F033E
	STDMETHOD(get_ChildRelIDCounter)(long *pVal) { 
		return inFCO->get_ChildRelIDCounter(pVal); }
	//##ModelId=3C5AA08F0351
	STDMETHOD(put_ChildRelIDCounter)(long pVal) { 
		return inFCO->put_ChildRelIDCounter(pVal); }
	
	//##ModelId=3C5AA08F035B
	STDMETHOD(get_Attributes)(/*[out, retval]*/ IMgaAttributes * *pVal)							{ return E_MGA_NOT_SUPPORTED; };
	//##ModelId=3C5AA08F0366
	STDMETHOD(get_Attribute)(/*[in]*/ IMgaMetaAttribute *meta, /*[out, retval]*/ VARIANT *pVal) { return E_MGA_NOT_SUPPORTED; };
	//##ModelId=3C5AA08F037A
	STDMETHOD(get_AttributeByName)(/*[in]*/ BSTR name, /*[out, retval]*/ VARIANT *pVal)			{ return E_MGA_NOT_SUPPORTED; };
	//##ModelId=3C5AA08F038E
	STDMETHOD(put_AttributeByName)(/*[in]*/ BSTR name, /*[in]*/ VARIANT newVal)					{ return E_MGA_NOT_SUPPORTED; };

	//##ModelId=3C5AA08F03A1
	STDMETHOD(get_StrAttrByName)( BSTR name,  BSTR *pVal) {  return E_MGA_NOT_SUPPORTED; }
	//##ModelId=3C5AA08F03B5
	STDMETHOD(put_StrAttrByName)( BSTR name,  BSTR newval) {  return E_MGA_NOT_SUPPORTED; }
	//##ModelId=3C5AA08F03C9
	STDMETHOD(get_IntAttrByName)( BSTR name,  long *pVal) {  return E_MGA_NOT_SUPPORTED; }
	//##ModelId=3C5AA08F03DD
	STDMETHOD(put_IntAttrByName)( BSTR name,  long newval) {  return E_MGA_NOT_SUPPORTED; }
	//##ModelId=3C5AA0900009
	STDMETHOD(get_FloatAttrByName)( BSTR name,  double *pVal) {  return E_MGA_NOT_SUPPORTED; }
	//##ModelId=3C5AA090001D
	STDMETHOD(put_FloatAttrByName)( BSTR name,  double newval) {  return E_MGA_NOT_SUPPORTED; }
	//##ModelId=3C5AA0900063
	STDMETHOD(get_BoolAttrByName)( BSTR name,  VARIANT_BOOL *pVal) {  return E_MGA_NOT_SUPPORTED; }
	//##ModelId=3C5AA0900077
	STDMETHOD(put_BoolAttrByName)( BSTR name,  VARIANT_BOOL newval) {  return E_MGA_NOT_SUPPORTED; }
	//##ModelId=3C5AA090008B
	STDMETHOD(get_RefAttrByName)( BSTR name,  IMgaFCO **pVal) {  return E_MGA_NOT_SUPPORTED; }
	//##ModelId=3C5AA090009F
	STDMETHOD(put_RefAttrByName)( BSTR name,  IMgaFCO * newval) {  return E_MGA_NOT_SUPPORTED; }
	//##ModelId=3C5AA09000B3
	STDMETHOD(RemoveAttrByName)( BSTR name) {  return E_MGA_NOT_SUPPORTED; }
	//##ModelId=3C5AA09000BE
	STDMETHOD(get_Meta)(IMgaMetaFCO * *pVal) { return E_MGA_NOT_SUPPORTED; }
	// by ZolMol
	//STDMETHOD(get_FolderMeta)(IMgaMetaFolder * *pVal) { return inFCO->get_MetaFolder( pVal); }

};

#endif //__MGAFOLDER_H_
