#ifndef DUMPER_H
#define DUMPER_H

#include "list"
#include "vector"
#include "Sheet.h"

class Dumper : public Sheet {

protected:
	Dumper();

public:
	static Sheet * getInstance();
	virtual ~Dumper();

	bool build();

	static int selectOutputFiles( const std::string& proj_name);
	static int backup( const std::string& file_name);
	static void getGlobalUserParts( std::string& up1, std::string& up2);

	static bool m_bParsePrev;
	static bool m_bGenInit;
	static bool m_bGenFinalize;
	static bool m_bGenTemplates;
	static bool m_bGenTemplVersion6;
	static bool m_bGenRegular;
	static bool m_bGenVisitor;
	static bool m_bSafetyBackup;

protected:

	void inheritMoReSeCoFolAsp();

	void showMultipleInheritance();

	void selConf( std::vector<FCO*>& s);

	void createMethods();
	void dumpGlobals( std::vector<FCO*>& s);
	void dumpGlobalMOF();
	void dumpMain( std::vector<FCO*>& s);
	void doDump();

	bool checkAll();
	bool checkAllFCOs();
	bool checkOrphanAttributes();
	bool findInFolders( FCO * fco);

	std::string getNamespaceName();

protected:
	void fetchConfigurationNames( std::vector< std::string>& res);

};


#endif //DUMPER_H
